
;;;        26020-83;;;;;;

(defun dv_t_rp (/     cmd   blpm	 apsz  osmd  cpt   ept	 hdv   bdv
	       hp1   hp2   hp3	 lp1   rd1   rd2   label sset  
	       edat3 cpt   ept	 pt0   pt1   pt2   pt3	 pt4   pt5
	       pt6   pt7   pt8	 pt9   pt10  pt11  pt12	 pt13  pt14
	       pt15  pt16  clay  cltp ccol
	      )

  (setq cmd (getvar "cmdecho"))
  (setq blpm (getvar "blipmode"))
  (setq apsz (getvar "aperture"))
  (setq osmd (getvar "osmode"))
  (setq clay (getvar "clayer"))
  (setq cltp (getvar "celtype"))
  (setq ccol (getvar "cecolor"))
  (setvar "cmdecho" 0)
  (setvar "blipmode" 0)

  (setq
    hdv	(nth 1 bb)
    bdv	(nth 2 bb)
    hp1	(nth 3 bb)
    hp2	(nth 4 bb)
    hp3	(nth 5 bb)
    lp1	(nth 6 bb)
    rd1	(nth 7 bb)
    rd2	(nth 8 bb)
  ) ;_ end of setq


  (defun lay_o ()
    (command "_'layer" "_m" "0" "_c" "7" "" "")
  ) ;_ end of defun

  (lay_o)

  (if (eq sec1 "0")
      (if (eq dlnug "1")
	(progn
	  (initget 1)
	  (setq cpt (getpoint "\n First point:"))
	  (initget 1)
	  (setq ept (polar cpt 0 (getdist cpt "\n Second point:")))
          (setq dlndt (itoa (fix (distance cpt ept))))
	) ;_ end of progn
	(setq cpt '(0.0 0.0)
	      ept (polar cpt 0 (read dlndt))
	) ;_ end of setq
      ) ;_ end of if
  ) ;_ end of if

  (defun ris_dvt ()

;;;  

    (defun dvt_gl_sz ()


      (setq pt3	(polar cpt (/ pi 2) hdv)
	    pt4	(polar ept (/ pi 2) hdv)
	    pt5	(polar cpt (/ pi 2) hp1)
	    pt7	(polar cpt (/ pi 2) hp2)
	    pt6	(polar ept (/ pi 2) hp1)
	    pt8	(polar ept (/ pi 2) hp2)
      ) ;_ end of setq

      (setvar "osmode" 0)
      (setvar "aperture" 1)
      (command "_linetype" "_s" "bylayer" "")
      (command "_color" "_byl")
      (command "_line" cpt ept "")
      (setq label (entlast))
      (setq sset (ssadd (entlast)))

      (command "_line" ept pt4 pt3 cpt "" 
               "_line" pt5 pt6 "" 
               "_line" pt7 pt8 "")
    )					;    dvt_gl_sz

;;;   

    (defun dvt_v_sv ()

      (setq pt3	(polar cpt (/ pi 2) bdv)
	    pt4	(polar ept (/ pi 2) bdv)
	    pt5	(polar cpt (/ pi 2) (/ (- bdv hp3) 2.0))
	    pt6	(polar ept (/ pi 2) (/ (- bdv hp3) 2.0))
	    pt7	(polar cpt (/ pi 2) (/ (+ bdv hp3) 2.0))
	    pt8	(polar ept (/ pi 2) (/ (+ bdv hp3) 2.0))
      ) ;_ end of setq

      (setvar "osmode" 0)
      (setvar "aperture" 1)
      (command "_linetype" "_s" "bylayer" "")
      (command "_color" "_byl")
      (command "_line" cpt ept "")
      (setq label (entlast))
      (setq sset (ssadd (entlast)))
      (command "_line" ept pt4 pt3 cpt "")
  (setvar "celtype" "ACAD_ISO02W100" )
      (command "_color" "1")
      (command "_line" pt5 pt6 "")
      (command "_line" pt7 pt8 "")
    )					;   dvt_v_sv

;;; 

    (defun dvt_sc ()

      (setq cpt '(0.0 0.0))

      (setvar "osmode" 0)
      (setvar "aperture" 1)
      (setq pt0 (polar cpt (/ pi 2) hdv)
            pt1 (polar cpt 0 (/ bdv 2.0))
            pt2 (polar pt1 (/ pi 2) hp1) 
            pt3 (polar pt2 pi (- (/ (- bdv hp3) 2.0) rd1)) 
            pt4 (polar pt3 (* (/ pi 4) 3) (* (sqrt 2.0) rd1)) 
            pt8 (polar pt0 0 (/ bdv 2.0)) 
            pt7 (polar pt8 (- (/ pi 2)) hp1) 
            pt6 (polar pt7 pi (- (/ (- bdv hp3) 2.0) rd1)) 
            pt5 (polar pt6 (- (* (/ pi 4) 3)) (* (sqrt 2.0) rd1)) 
            pt9 (polar pt8 pi bdv) 
            pt10 (polar pt7 pi bdv) 
            pt11 (polar pt10 0 (- (/ (- bdv hp3) 2.0) rd1)) 
            pt12 (polar pt11 (- (/ pi 4)) (* (sqrt 2.0) rd1)) 
            pt16 (polar pt1 pi bdv) 
            pt15 (polar pt2 pi bdv) 
            pt14 (polar pt15 0 (- (/ (- bdv hp3) 2.0) rd1)) 
            pt13 (polar pt14 (/ pi 4) (* (sqrt 2.0) rd1))
       ) ;_end of setq


      (command "_linetype" "_s" "bylayer" "")
      (command "_color" "_byl")
      (command "_line" pt4 pt5 "")
      (setq label (entlast))
      (setq sset (ssadd (entlast)))

      (command "_line" pt3 pt2 pt1 pt16 pt15 pt14 "" 
               "_line" pt13 pt12 "" 
               "_line" pt11 pt10 pt9 pt8 pt7 pt6 ""
               "_arc" pt6 "_e" pt5 "_r" rd1 
               "_arc" pt12 "_e" pt11 "_r" rd1 
               "_arc" pt4 "_e" pt3 "_r" rd1 
               "_arc" pt14 "_e" pt13 "_r" rd1)

    )					;    dvt_sc


    (cond ((= glv1 "1") (dvt_gl_sz))
	  ((= vsv1 "1") (dvt_v_sv))
	  ((= sec1 "1") (dvt_sc))
    ) ;_ end of cond

    (setvar "cmdecho" cmd)
    (setvar "blipmode" blpm)
    (setvar "aperture" apsz)
    (setvar "osmode" osmd)

    (while (setq label (entnext label))
      (setq sset (ssadd label sset))
    ) ;_ end of while

  ) ;_ end of defun
;;;_end of RIS_DVT


  (defun edat ()
    (cond ((eq glv1 "1")  (setq nmpr "A"))
          ((eq vsv1 "1")  (setq nmpr "E"))
          ((eq sec1 "1")  (setq nmpr "F"))
     )
    (setq edat3 (strcat "AP" nmpr pr_fl rr dlndt))
  ) ;_ end of defun

  (defun clip_bl ()
    (edat)
    (if	(eq (tblsearch "block" edat3) nil)
      (progn
	(ris_dvt)
	(command "._block" edat3 cpt sset "")
        (setvar "clayer" clay)
	(command "._insert" edat3 pause 1 1 pause)
      ) ;_ end of progn
      (progn
        (setvar "clayer" clay)
        (command "._insert" edat3 pause 1 1 pause)
      ) ;_ end of progn
    ) ;_end of if
    (setvar "celtype" cltp)
    (setvar "cecolor" ccol)
  ) ;_ end of defun CLIP_BL

  (clip_bl)
  (prin1)

) ;_end of defun DV_T_RP
