
;;;  

(defun dv_t_r (/     cmd   blpm	 apsz  osmd  cpt   ept	 hdv   bdv
	       hp1   hp2   hp3	 lp1   rd1   rd2   label sset  edat3
	       cpt   ept   pt0	 pt1   pt2   pt3   pt4	 pt5   pt6
	       pt7   pt8   pt9	 pt10  pt11  pt12  pt13	 pt14  pt15
	       pt16  pt17  pt18	 pt19  pt20  pt21  clay	 cltp  ccol
	      )

  (setq cmd (getvar "cmdecho"))
  (setq blpm (getvar "blipmode"))
  (setq apsz (getvar "aperture"))
  (setq osmd (getvar "osmode"))
  (setq clay (getvar "clayer"))
  (setq cltp (getvar "celtype"))
  (setq ccol (getvar "cecolor"))
  (setvar "cmdecho" 0)
  (setvar "blipmode" 0)

  (setq
    hdv	(nth 1 bb)
    bdv	(nth 2 bb)
    hp1	(nth 3 bb)
    hp2	(nth 4 bb)
    hp3	(nth 5 bb)
    lp1	(nth 6 bb)
    rd1	(nth 7 bb)
    rd2	(nth 8 bb)
  ) ;_ end of setq


  (defun lay_o ()
    (command "_'layer" "_s" "0" "")
  ) ;_ end of defun

  (lay_o)

  (if (eq sec1 "0")
    (if	(eq dlnug "1")
      (progn
	(initget 1)
	(setq cpt (getpoint "\n First point:"))
	(initget 1)
	(setq ept (polar cpt 0 (getdist cpt "\n Second point:")))
	(setq dlndt (itoa (fix (distance cpt ept))))
      ) ;_ end of progn
      (setq cpt	'(0.0 0.0)
	    ept	(polar cpt 0 (read dlndt))
      ) ;_ end of setq
    ) ;_ end of if
  ) ;_ end of if

  (defun ris_dvt ()

;;;  

    (defun dvt_gl_sz ()


      (setq pt3	(polar cpt (/ pi 2) hdv)
	    pt4	(polar ept (/ pi 2) hdv)
	    pt5	(polar cpt (/ pi 2) hp1)
	    pt7	(polar cpt (/ pi 2) hp2)
	    pt6	(polar ept (/ pi 2) hp1)
	    pt8	(polar ept (/ pi 2) hp2)
      ) ;_ end of setq

      (setvar "osmode" 0)
      (setvar "aperture" 1)
      (command "_linetype" "_s" "bylayer" "")
      (command "_color" "_byl")
      (command "_line" cpt ept "")
      (setq label (entlast))
      (setq sset (ssadd (entlast)))

      (command "_line" ept pt4 pt3 cpt "")
      (command "_line" pt5 pt6 "")
      (command "_line" pt7 pt8 "")
    )			      ;    dvt_gl_sz

;;;   

    (defun dvt_v_sv ()

      (setq pt3	(polar cpt (/ pi 2) bdv)
	    pt4	(polar ept (/ pi 2) bdv)
	    pt5	(polar cpt (/ pi 2) (/ (- bdv hp3) 2.0000))
	    pt6	(polar ept (/ pi 2) (/ (- bdv hp3) 2.0000))
	    pt7	(polar cpt (/ pi 2) (/ (+ bdv hp3) 2.0000))
	    pt8	(polar ept (/ pi 2) (/ (+ bdv hp3) 2.0000))
      ) ;_ end of setq

      (setvar "osmode" 0)
      (setvar "aperture" 1)
      (command "_linetype" "_s" "bylayer" "")
      (command "_color" "_byl")
      (command "_line" cpt ept "")
      (setq label (entlast))
      (setq sset (ssadd (entlast)))
      (command "_line" ept pt4 pt3 cpt "")

      (setvar "celtype" "ACAD_ISO02W100")
      (command "_color" "1")
      (command "_line" pt5 pt6 "")
      (command "_line" pt7 pt8 "")
    )			      ;   dvt_v_sv

;;; 

    (defun dvt_sc ()

      (setq cpt '(0.0 0.0))

      (setvar "osmode" 0)
      (setvar "aperture" 1)
      (setq pt0 (polar cpt (/ pi 2) (/ hdv 2.0000)))
      (setq pt1 (polar cpt 0 (/ bdv 2.0000)))
      (setq pt11 (polar cpt (/ pi 2) hdv))
      (setq pt10 (polar pt11 0 (/ bdv 2.0000)))
      (setq pt2 (polar pt1 (/ pi 2) lp1))
      (setq pt9 (polar pt10 (/ (* pi 3) 2) lp1))
      (setq pt8	(polar pt9
		       (/ (* pi 91) 72)
		       (* 2.0000 (* rd1 (sin (/ (* pi 17) 72))))
		) ;_ end of polar
      ) ;_ end of setq
      (setq pt3	(polar pt2
		       (/ (* pi 53) 72)
		       (* 2.0000 (* rd1 (sin (/ (* pi 17) 72))))
		) ;_ end of polar
      ) ;_ end of setq
      (setq pt4	(polar pt3
		       (/ (* pi 175) 180)
		       (/ (- (/ (- bdv hp3) 2.0000)
			     (* (- 1 (sin (/ pi 36))) (+ rd1 rd2))
			  ) ;_ end of -
			  (cos (/ pi 36))
		       ) ;_ end of /
		) ;_ end of polar
      ) ;_ end of setq
      (setq pt7	(polar pt8
		       (/ (* pi 185) 180)
		       (/ (- (/ (- bdv hp3) 2.0000)
			     (* (- 1 (sin (/ pi 36))) (+ rd1 rd2))
			  ) ;_ end of -
			  (cos (/ pi 36))
		       ) ;_ end of /
		) ;_ end of polar
      ) ;_ end of setq
      (setq pt5	(polar pt4
		       (/ (* pi 53) 72)
		       (* 2.0000 (* rd2 (sin (/ (* pi 17) 72))))
		) ;_ end of polar
      ) ;_ end of setq
      (setq pt6	(polar pt7
		       (/ (* pi 91) 72)
		       (* 2.0000 (* rd2 (sin (/ (* pi 17) 72))))
		) ;_ end of polar
      ) ;_ end of setq

      (setq pt21 (polar pt10 pi bdv))
      (setq pt20 (polar pt1 pi bdv))
      (setq pt19 (polar pt20 (/ pi 2) lp1))
      (setq pt12 (polar pt21 (/ (* pi 3) 2) lp1))
      (setq pt13 (polar	pt12
			(/ (* pi 125) 72)
			(* 2.0000 (* rd1 (sin (/ (* pi 17) 72))))
		 ) ;_ end of polar
      ) ;_ end of setq
      (setq pt18 (polar	pt19
			(/ (* pi 19) 72)
			(* 2.0000 (* rd1 (sin (/ (* pi 17) 72))))
		 ) ;_ end of polar
      ) ;_ end of setq
      (setq
	pt14 (polar pt13
		    (/ (* pi 71) 36)
		    (/ (- (/ (- bdv hp3) 2.0000)
			  (* (- 1 (sin (/ pi 36))) (+ rd1 rd2))
		       ) ;_ end of -
		       (cos (/ pi 36))
		    ) ;_ end of /
	     ) ;_ end of polar
      ) ;_ end of setq
      (setq
	pt17 (polar pt18
		    (/ pi 36)
		    (/ (- (/ (- bdv hp3) 2.0000)
			  (* (- 1 (sin (/ pi 36))) (+ rd1 rd2))
		       ) ;_ end of -
		       (cos (/ pi 36))
		    ) ;_ end of /
	     ) ;_ end of polar
      ) ;_ end of setq
      (setq pt16 (polar	pt17
			(/ (* pi 19) 72)
			(* 2.0000 (* rd2 (sin (/ (* pi 17) 72))))
		 ) ;_ end of polar
      ) ;_ end of setq
      (setq pt15 (polar	pt14
			(/ (* pi 125) 72)
			(* 2.0000 (* rd2 (sin (/ (* pi 17) 72))))
		 ) ;_ end of polar
      ) ;_ end of setq

      (command "_linetype" "_s" "_bylayer" "")
      (command "_color" "_byl")
      (command "_line" pt2 pt1 "")
      (setq label (entlast))
      (setq sset (ssadd (entlast)))

      (command "_line" pt1 pt20 pt19 "")
      (command "_line" pt12 pt21 pt10 pt9 "")
      (command "_arc" pt8 "_e" pt9 "_r" rd1)
      (command "_arc" pt2 "_e" pt3 "_r" rd1)
      (command "_line" pt8 pt7 "")
      (command "_line" pt3 pt4 "")
      (command "_arc" pt5 "_e" pt4 "_r" rd2)
      (command "_arc" pt7 "_e" pt6 "_r" rd2)
      (command "_line" pt5 pt6 "")
      (command "_arc" pt12 "_e" pt13 "_r" rd1)
      (command "_arc" pt18 "_e" pt19 "_r" rd1)
      (command "_line" pt13 pt14 "")
      (command "_line" pt18 pt17 "")
      (command "_arc" pt15 "_e" pt14 "_r" rd2)
      (command "_arc" pt17 "_e" pt16 "_r" rd2)
      (command "_line" pt16 pt15 "")

    )			      ;    dvt_sc


    (cond ((= glv1 "1") (dvt_gl_sz))
	  ((= vsv1 "1") (dvt_v_sv))
	  ((= sec1 "1") (dvt_sc))
    ) ;_ end of cond

    (setvar "cmdecho" cmd)
    (setvar "blipmode" blpm)
    (setvar "aperture" apsz)
    (setvar "osmode" osmd)

    (while (setq label (entnext label))
      (setq sset (ssadd label sset))
    ) ;_ end of while

  ) ;_ end of defun
;;;_end of RIS_DVT


  (defun edat ()
    (cond ((eq glv1 "1") (setq nmpr "A"))
	  ((eq vsv1 "1") (setq nmpr "E"))
	  ((eq sec1 "1") (setq nmpr "F"))
    ) ;_  cond
    (setq edat3 (strcat "A" nmpr pr_fl rr dlndt))
  ) ;_ end of defun

  (defun clip_bl ()
    (edat)
    (if	(eq (tblsearch "block" edat3) nil)
      (progn
	(ris_dvt)
	(command "._block" edat3 cpt sset "")
	(setvar "clayer" clay)
	(command "._insert" edat3 pause 1 1 pause)
      ) ;_ end of progn
      (progn
	(setvar "clayer" clay)
	(command "._insert" edat3 pause 1 1 pause)
      ) ;_ end of progn
    ) ;_end of if
    (setvar "celtype" cltp)
    (setvar "cecolor" ccol)
  ) ;_ end of defun CLIP_BL

  (clip_bl)
  (prin1)

) ;_end of defun DV_T_R
;|Visual LISP Format Options
(72 2 30 2 T " " 72 9 1 1 0 T T nil T)
;***     ! ***|;
