

;;; 

(defun sv_l_rg (/      cmd    blpm   apsz   osmd   cpt	  ept	 hsvg
		bsvg   ssvg   rsvg   sset   label  edat3  pt1	 pt2
		pt3    pt4    pt5    pt6    pt7	   pt8	  pt9	 pt10
		pt11   pt12   clay   cltp   ccol
	       )

  (setq cmd (getvar "cmdecho"))
  (setq blpm (getvar "blipmode"))
  (setq apsz (getvar "aperture"))
  (setq osmd (getvar "osmode"))
  (setq clay (getvar "clayer"))
  (setq cltp (getvar "celtype"))
  (setq ccol (getvar "cecolor"))
  (setvar "cmdecho" 0)
  (setvar "blipmode" 0)

  (setq	hsvg (nth 1 bb)
	bsvg (nth 2 bb)
	ssvg (nth 3 bb)
	rsvg (nth 4 bb)
  ) ;_ end of setq

  (defun lay_o ()
    (command "_'layer" "_s" "0" "")
  ) ;_ end of defun

  (lay_o)

  (if (eq sec1 "0")
    (if	(eq dlnug "1")
      (progn
	(initget 1)
	(setq cpt (getpoint "\n First point:"))
	(initget 1)
	(setq ept (polar cpt 0 (getdist cpt "\n Second point:")))
	(setq dlndt (itoa (fix (distance cpt ept))))
      ) ;_ end of progn
      (setq cpt	'(0.0 0.0)
	    ept	(polar cpt 0 (read dlndt))
      ) ;_ end of setq
    ) ;_ end of if
  ) ;_ end of if

  (defun ris_shrg ()

;;;     


    (defun shv_gl_szg ()

      (setq pt3	(polar cpt (/ pi 2) hsvg)
	    pt4	(polar ept (/ pi 2) hsvg)
	    pt5	(polar cpt (/ pi 2) ssvg)
	    pt7	(polar pt3 (/ (* pi 3) 2) ssvg)
	    pt6	(polar ept (/ pi 2) ssvg)
	    pt8	(polar pt4 (/ (* pi 3) 2) ssvg)
      ) ;_ end of setq

      (setvar "osmode" 0)
      (setvar "aperture" 1)
      (command "_linetype" "_s" "bylayer" "")
      (command "_color" "_byl")
      (command "_line" cpt ept "")
      (setq label (entlast))
      (setq sset (ssadd (entlast)))

      (command "_line" ept pt4 pt3 cpt "")
      (if (eq vsz1 "1")
	(progn
	  (setvar "celtype" "ACAD_ISO02W100")
	  (command "_color" "1")
	) ;_  progn
	(progn
	  (command "_linetype" "_s" "_bylayer" "")
	  (command "_color" "_byl")
	) ;_  progn
      ) ;_ end of if
      (command "_line" pt5 pt6 "")
      (command "_line" pt7 pt8 "")

    ) ;_ end of defun

;;;  

    (defun shv_v_svg ()

      (setq pt3	(polar cpt (/ pi 2) bsvg)
	    pt4	(polar ept (/ pi 2) bsvg)
	    pt5	(polar pt3 (/ (* pi 3) 2) ssvg)
	    pt6	(polar pt4 (/ (* pi 3) 2) ssvg)
      ) ;_ end of setq

      (setvar "osmode" 0)
      (setvar "aperture" 1)
      (command "_linetype" "_s" "_bylayer" "")
      (command "_color" "_byl")
      (command "_line" cpt ept "")
      (setq label (entlast))
      (setq sset (ssadd (entlast)))
      (command "_line" ept pt4 pt3 cpt "")

      (setvar "celtype" "ACAD_ISO02W100")
      (command "_color" "1")
      (command "_line" pt5 pt6 "")

    )			      ;    shv_v_svg

;;; 

    (defun shv_scg ()

      (setq cpt '(0.0 0.0))

      (setvar "osmode" 0)
      (setvar "aperture" 1)
      (setq pt1	 (polar cpt 0 (+ ssvg rsvg))
	    pt12 (polar cpt (/ pi 2) (+ ssvg rsvg))
	    pt10 (polar pt1 (/ pi 2) hsvg)
	    pt4	 (polar pt1 (/ pi 2) ssvg)
	    pt7	 (polar pt10 (/ (* pi 3) 2) ssvg)
	    pt2	 (polar cpt 0 bsvg)
	    pt3	 (polar pt2 (/ pi 2) ssvg)
	    pt9	 (polar pt2 (/ pi 2) hsvg)
	    pt8	 (polar pt9 (/ (* pi 3) 2) ssvg)
	    pt5	 (polar pt12 0 ssvg)
	    pt11 (polar cpt (/ pi 2) (- hsvg (+ ssvg rsvg)))
	    pt6	 (polar pt11 0 ssvg)
      ) ;_ end of setq

      (command "_linetype" "_s" "_bylayer" "")
      (command "_color" "_byl")

      (command "_line" pt4 pt3 "")
      (setq label (entlast))
      (setq sset (ssadd (entlast)))


      (command "_line" pt3 pt2 pt1 "")
      (command "_arc" pt7 "_e" pt6 "_r" rsvg)
      (command "_arc" pt10 "_e" pt11 "_r" (+ rsvg ssvg))
      (command "_line" pt10 pt9 pt8 pt7 "")
      (command "_line" pt11 pt12 "")
      (command "_arc" pt5 "_e" pt4 "_r" rsvg)
      (command "_arc" pt12 "_e" pt1 "_r" (+ rsvg ssvg))
      (command "_line" pt5 pt6 "")
    )			      ;    shv_scg

    (cond ((or (= glv1 "1") (= vsz1 "1")) (shv_gl_szg))
	  ((= vsv1 "1") (shv_v_svg))
	  ((= sec1 "1") (shv_scg))
    ) ;_ end of cond

    (setvar "cmdecho" cmd)
    (setvar "blipmode" blpm)


    (while (setq label (entnext label))
      (setq sset (ssadd label sset))
    ) ;_ end of while

  ) ;_end of defun RIS_SHRG

  (defun edat ()
    (cond ((eq glv1 "1") (setq nmpr "A"))
	  ((eq vsz1 "1") (setq nmpr "C"))
	  ((eq vsv1 "1") (setq nmpr "E"))
	  ((eq sec1 "1") (setq nmpr "F"))
    ) ;_  cond
    (setq edat3 (strcat "D" nmpr pr_fl rr dlndt))
  ) ;_ end of defun

  (defun clip_bl ()
    (edat)
    (if	(eq (tblsearch "block" edat3) nil)
      (progn
	(ris_shrg)
	(command "._block" edat3 cpt sset "")
	(setvar "aperture" apsz)
	(setvar "osmode" osmd)
	(setvar "clayer" clay)
	(command "._insert" edat3 pause 1 1 pause)
      ) ;_ end of progn
      (progn
	(setvar "clayer" clay)
	(command "._insert" edat3 pause 1 1 pause)
      ) ;_ end of progn
    ) ;_end of if
    (setvar "celtype" cltp)
    (setvar "cecolor" ccol)
  ) ;_ end of defun CLIP_BL

  (clip_bl)
  (prin1)

)			      ;    SV_L_RG
;|Visual LISP Format Options
(72 2 30 2 T " " 72 9 1 1 0 T T nil T)
;***     ! ***|;
