(defun c:flatten_vc ( / ss n i e )

  (SETQ ss (ssget "X")
	n (sslength ss)
	i 0
  )

  (while (< i n)
    (setq e (ssname ss i))
    (parse_ent e)
    (setq i (1+ i))
    (princ (strcat "\r " (itoa i) " "))
  )
   (princ)
)

(defun parse_ent (e / lo lpt pto j)
    (setq lo (entget e)
	  j 10)

    (while (< j 19)
	   (if (setq lpt (assoc j lo))
		   (progn
		    (setq pto (list (car (cdr lpt)) (cadr (cdr lpt)) 0)
		          lo (subst (cons j pto) lpt lo)
		    )
		   )
	   )
      (setq j (1+ j))
    )
    (entmod lo)

    (check_block e)
)


(defun check_block (ent / btr subent)
   (if (= (cdr (assoc 0 (entget ent))) "INSERT")
     (progn
       (setq btr (tblobjname "Block" (cdr (assoc 2 (entget ent)))))
       (if btr
	 (progn
	   (parse_subent btr)
	 )
       )
     )
   )
)

(defun parse_subent (ent / subent)
  (setq subent (entnext ent))
  (while subent
    (parse_ent subent)
    (setq subent (entnext subent))
  )
)