;;------> PROKAT <--------------------------------------------
;; version 20-06-2000
;; :  .
;;----------------------------------------------------------------------------------------	
;; version 14-01-2008   ZWCAD
;; : Alan.
;;   "prokat  25.07.07"
;;----------------------------------------------------------------------------------------	
;; version 24-12-2006
;;   :  .
;;           , .
;;        mail: flashcon@yandex.ru
;;----------------------------------------------------------------------------------------	

;;;      


(defun c:prokat	(/	dvtp   dvt    shr    shp    shg	   ugr
		 ugn	ugrg   trprf  ugng   dvcl   lib	   dvd
		 dvdp	svrd   svpd   svgd   ugrd   svgkd  uggrkd
		 uggnkd	dvdpas trkvd  trpud  uggrd  uggnd  ugnd
		 name1	orx    aby    glv1   glvm1  vsz1   vszm1
		 vsv1	sec1   x      a	     aa	    aaa	   b
		 bb	bbb    dlnug  spr    dlndt
;;;      19425-74
		 dvd1	dvd2
		)
(setvar "cmdecho" 0)
;;;    DASHED
  (if (tblsearch "LTYPE" "ACAD_ISO02W100")
    nil
    (command "_.LINETYPE"
	     "_L"
	     "ACAD_ISO02W100"
	     "acadiso"
	     ""
    ) ;_  command
  ) ;_  if

  (setq	dvtp   (findfile "prokat/dvt_p.lsp")
	dvt    (findfile "prokat/dvt_r.lsp")
	shr    (findfile "prokat/shv_r.lsp")
	shp    (findfile "prokat/shv_rp.lsp")
	shg    (findfile "prokat/shv_rg.lsp")
	ugr    (findfile "prokat/ug_rp.lsp")
	ugn    (findfile "prokat/ug_np.lsp")
	ugrg   (findfile "prokat/ug_rg.lsp")
	ugng   (findfile "prokat/ug_ng.lsp")
	trprf  (findfile "prokat/tr_prf.lsp")

	dvcl   (findfile "prokat/d_vtr.dcl")
	lib    (findfile "prokat/procat.slb")
	dvdp   (findfile "prokat/dvtp.dat")
	dvdpas (findfile "prokat/dvtpas.dat")
	dvd    (findfile "prokat/dvtr.dat")
	dvd1   (findfile "prokat/dvtr2.dat")
	dvd2   (findfile "prokat/dvtp2.dat")
	svrd   (findfile "prokat/svlr.dat")
	svpd   (findfile "prokat/svlrp.dat")
	svgd   (findfile "prokat/svlrg.dat")
	svgkd  (findfile "prokat/svlrgK.dat")
	ugrd   (findfile "prokat/ugrp.dat")
	uggrd  (findfile "prokat/ugrg.dat")
	uggrkd (findfile "prokat/ugrgK.dat")
	uggnd  (findfile "prokat/ugng.dat")
	uggnkd (findfile "prokat/ugngK.dat")
	ugnd   (findfile "prokat/ugnp.dat")
	trkvd  (findfile "prokat/trkv.dat")
	trpud  (findfile "prokat/trpu.dat")
  ) ;_ end of setq
  (load dvtp)
  (load dvt)
  (load shr)
  (load shp)
  (load shg)
  (load ugr)
  (load ugn)
  (load ugrg)
  (load ugng)
  (load trprf)

  (defun show_im2 (name1)
    (setq orx (dimx_tile "show_image1")
	  aby (dimy_tile "show_image1")
    ) ;_ end of setq
    (start_image "show_image1")
    (fill_image 0 0 orx aby 444)
    (slide_image 0 0 orx aby name1)
    (end_image)
  ) ;_ end of defun


  (defun r10 ()
    (cond
      ((or (eq pr_fl "0")
	   (eq pr_fl "1")
	   (eq pr_fl "2")
	   (eq pr_fl "3")
	   (eq pr_fl "4")
       ) ;_  or
       (progn
	 (mode_tile "glv" 0)
	 (mode_tile "glvm" 1)
	 (mode_tile "vsz" 1)
	 (mode_tile "vszm" 1)
	 (mode_tile "vsv" 0)
	 (mode_tile "sec" 0)
       ) ;_ end of progn
      )
      ((or (eq pr_fl "5")
	   (eq pr_fl "6")
	   (eq pr_fl "7")
	   (eq pr_fl "8")
       ) ;_  or
       (progn
	 (mode_tile "glv" 0)
	 (mode_tile "glvm" 1)
	 (mode_tile "vsz" 0)
	 (mode_tile "vszm" 1)
	 (mode_tile "vsv" 0)
	 (mode_tile "sec" 0)
       ) ;_ end of progn
      )
      ((or (eq pr_fl "9")
	   (eq pr_fl "11")
	   (eq pr_fl "12")
       ) ;_  or
       (progn
	 (mode_tile "glv" 0)
	 (mode_tile "glvm" 1)
	 (mode_tile "vsz" 0)
	 (mode_tile "vszm" 1)
	 (mode_tile "vsv" 1)
	 (mode_tile "sec" 0)
       ) ;_ end of progn
      )
      ((or (eq pr_fl "10")
	   (eq pr_fl "13")
	   (eq pr_fl "14")
       ) ;_  or
       (progn
	 (mode_tile "glv" 0)
	 (mode_tile "glvm" 0)
	 (mode_tile "vsz" 0)
	 (mode_tile "vszm" 0)
	 (mode_tile "vsv" 1)
	 (mode_tile "sec" 0)
       ) ;_ end of progn
      )
      ((eq pr_fl "15")
       (progn
	 (mode_tile "glv" 0)
	 (mode_tile "glvm" 1)
	 (mode_tile "vsz" 1)
	 (mode_tile "vszm" 1)
	 (mode_tile "vsv" 1)
	 (mode_tile "sec" 0)
       ) ;_ end of progn
      )
      ((eq pr_fl "16")
       (progn
	 (mode_tile "glv" 0)
	 (mode_tile "glvm" 1)
	 (mode_tile "vsz" 1)
	 (mode_tile "vszm" 1)
	 (mode_tile "vsv" 0)
	 (mode_tile "sec" 0)
       ) ;_ end of progn
      )
    ) ;_ end of cond
  ) ;_ end of defun

  (defun name ()
    (cond
      ((and (eq glv1 "1")
	    (eq vsv1 "0")
	    (eq sec1 "0")
	    (or	(eq pr_fl "0")
		(eq pr_fl "1")
		(eq pr_fl "2")
		(eq pr_fl "3")
		(eq pr_fl "4")
		(eq pr_fl "5")
		(and (eq pr_fl "6") (eq vsz1 "0"))
		(and (eq pr_fl "7") (eq vsz1 "0"))
		(and (eq pr_fl "8") (eq vsz1 "0"))
	    ) ;_ end of or
       ) ;_ end of and
       (setq name1
	      (strcat lib "(1)")
       ) ;_ end of setq
      )
      ((and (or	(eq pr_fl "0")
		(eq pr_fl "1")
		(eq pr_fl "2")
		(eq pr_fl "3")
	    ) ;_  or
	    (eq glv1 "0")
	    (eq vsv1 "1")
	    (eq sec1 "0")
       ) ;_ end of and
       (setq name1
	      (strcat lib "(2)")
       ) ;_ end of setq
      )
      ((and (or	(eq pr_fl "2")
		(eq pr_fl "3")
	    ) ;_  or
	    (eq glv1 "0")
	    (eq vsv1 "0")
	    (eq sec1 "1")
       ) ;_ end of and
       (setq name1
	      (strcat lib "(3)")
       ) ;_ end of setq
      )
      ((and (or	(eq pr_fl "5")
		(eq pr_fl "6")
		(eq pr_fl "7")
		(eq pr_fl "8")
		(eq pr_fl "4")
	    ) ;_  or
	    (eq glv1 "0")
	    (eq vsz1 "1")
	    (eq vsv1 "0")
	    (eq sec1 "0")
       ) ;_ end of and
       (setq name1
	      (strcat lib "(4)")
       ) ;_ end of setq
      )
      ((and (or	(eq pr_fl "5")
		(eq pr_fl "6")
		(eq pr_fl "7")
		(eq pr_fl "8")
		(eq pr_fl "4")
	    ) ;_  or
	    (eq glv1 "0")
	    (eq vsz1 "0")
	    (eq vsv1 "1")
	    (eq sec1 "0")
       ) ;_ end of and
       (setq name1
	      (strcat lib "(5)")
       ) ;_ end of setq
      )
      ((and (or (eq pr_fl "5") (eq pr_fl "4"))
	    (eq glv1 "0")
	    (eq vsz1 "0")
	    (eq vsv1 "0")
	    (eq sec1 "1")
       ) ;_ end of and
       (setq name1
	      (strcat lib "(6)")
       ) ;_ end of setq
      )
      ((and (eq pr_fl "6")
	    (eq glv1 "0")
	    (eq vsz1 "0")
	    (eq vsv1 "0")
	    (eq sec1 "1")
       ) ;_ end of and
       (setq name1
	      (strcat lib "(7)")
       ) ;_ end of setq
      )
      ((and (or (eq pr_fl "7") (eq pr_fl "8"))
	    (eq glv1 "0")
	    (eq vsz1 "0")
	    (eq vsv1 "0")
	    (eq sec1 "1")
       ) ;_ end of and
       (setq name1
	      (strcat lib "(8)")
       ) ;_ end of setq
      )
      ((and (or (eq pr_fl "9") (eq pr_fl "11") (eq pr_fl "12"))
	    (eq glv1 "1")
	    (eq vsz1 "0")
	    (eq sec1 "0")
       ) ;_ end of and
       (setq name1
	      (strcat lib "(9)")
       ) ;_ end of setq
      )
      ((and (or (eq pr_fl "9") (eq pr_fl "11") (eq pr_fl "12"))
	    (eq glv1 "0")
	    (eq vsz1 "1")
	    (eq sec1 "0")
       ) ;_ end of and
       (setq name1
	      (strcat lib "(10)")
       ) ;_ end of setq
      )
      ((and (eq pr_fl "9")
	    (eq glv1 "0")
	    (eq vsz1 "0")
	    (eq sec1 "1")
       ) ;_ end of and
       (setq name1
	      (strcat lib "(11)")
       ) ;_ end of setq
      )
      ((and (or (eq pr_fl "10") (eq pr_fl "13") (eq pr_fl "14"))
	    (eq glv1 "1")
	    (eq glvm1 "0")
	    (eq vsz1 "0")
	    (eq vszm1 "0")
	    (eq sec1 "0")
       ) ;_ end of and
       (setq name1
	      (strcat lib "(12)")
       ) ;_ end of setq
      )
      ((and (or (eq pr_fl "10") (eq pr_fl "13") (eq pr_fl "14"))
	    (eq glv1 "0")
	    (eq glvm1 "1")
	    (eq vsz1 "0")
	    (eq vszm1 "0")
	    (eq sec1 "0")
       ) ;_ end of and
       (setq name1
	      (strcat lib "(13)")
       ) ;_ end of setq
      )
      ((and (or (eq pr_fl "10") (eq pr_fl "13") (eq pr_fl "14"))
	    (eq glv1 "0")
	    (eq glvm1 "0")
	    (eq vsz1 "1")
	    (eq vszm1 "0")
	    (eq sec1 "0")
       ) ;_ end of and
       (setq name1
	      (strcat lib "(14)")
       ) ;_ end of setq
      )
      ((and (or (eq pr_fl "10") (eq pr_fl "13") (eq pr_fl "14"))
	    (eq glv1 "0")
	    (eq glvm1 "0")
	    (eq vsz1 "0")
	    (eq vszm1 "1")
	    (eq sec1 "0")
       ) ;_ end of and
       (setq name1
	      (strcat lib "(15)")
       ) ;_ end of setq
      )
      ((and (eq pr_fl "10")
	    (eq glv1 "0")
	    (eq glvm1 "0")
	    (eq vsz1 "0")
	    (eq vszm1 "0")
	    (eq sec1 "1")
       ) ;_ end of and
       (setq name1
	      (strcat lib "(16)")
       ) ;_ end of setq
      )
      ((and (or (eq pr_fl "11") (eq pr_fl "12"))
	    (eq glv1 "0")
	    (eq vsz1 "0")
	    (eq sec1 "1")
       ) ;_ end of and
       (setq name1
	      (strcat lib "(17)")
       ) ;_ end of setq
      )
      ((and (or (eq pr_fl "13") (eq pr_fl "14"))
	    (eq glv1 "0")
	    (eq glvm1 "0")
	    (eq vsz1 "0")
	    (eq vszm1 "0")
	    (eq sec1 "1")
       ) ;_ end of and
       (setq name1
	      (strcat lib "(18)")
       ) ;_ end of setq
      )
      ((and (or (eq pr_fl "0") (eq pr_fl "1"))
	    (eq glv1 "0")
	    (eq vsv1 "0")
	    (eq sec1 "1")
       ) ;_ end of and
       (setq name1
	      (strcat lib "(19)")
       ) ;_ end of setq
      )
      ((and (eq pr_fl "15")
	    (eq glv1 "0")
	    (eq vsv1 "0")
	    (eq sec1 "1")
       ) ;_ end of and
       (setq name1
	      (strcat lib "(20)")
       ) ;_ end of setq
      )
      ((and (eq pr_fl "15")
	    (eq glv1 "1")
	    (eq vsv1 "0")
	    (eq sec1 "0")
       ) ;_ end of and
       (setq name1
	      (strcat lib "(21)")
       ) ;_ end of setq
      )
      ((and (eq pr_fl "16")
	    (eq glv1 "0")
	    (eq vsv1 "0")
	    (eq sec1 "1")
       ) ;_ end of and
       (setq name1
	      (strcat lib "(22)")
       ) ;_ end of setq
      )
      ((and (eq pr_fl "16")
	    (eq glv1 "1")
	    (eq vsv1 "0")
	    (eq sec1 "0")
       ) ;_ end of and
       (setq name1
	      (strcat lib "(23)")
       ) ;_ end of setq
      )
      ((and (eq pr_fl "16")
	    (eq glv1 "0")
	    (eq vsv1 "1")
	    (eq sec1 "0")
       ) ;_ end of and
       (setq name1
	      (strcat lib "(24)")
       ) ;_ end of setq
      )
    ) ;_ end of cond
  ) ;_ end of defun

  (defun show (/ dcl_id)
    (setq dcl_id
	   (load_dialog
	     dvcl
	   ) ;_ end of load_dialog
    )			      ; DCL-
    (if	(not (new_dialog "dvtr" dcl_id)) ; 
      (exit)
    )			      ;(,   )

    (defun sn_def ()
      (setq glv1 "0"
	    glvm1 "0"
	    vsz1 "0"
	    vszm1 "0"
	    vsv1 "0"
	    sec1 "1"
;;;	    rr "0"   ;  2007 Alan
      ) ;_ end of setq
    ) ;_ end of defun

    (defun name_fil ()
      (cond
	((eq pr_fl "0") (setq fil dvdp))
	((eq pr_fl "1") (setq fil dvdpas))
	((eq pr_fl "2") (setq fil dvd))
	((eq pr_fl "3") (setq fil dvd1))
	((eq pr_fl "4") (setq fil dvd2))
	((eq pr_fl "5") (setq fil svrd))
	((eq pr_fl "6") (setq fil svpd))
	((eq pr_fl "7") (setq fil svgd))
	((eq pr_fl "8") (setq fil svgkd))
	((eq pr_fl "9") (setq fil ugrd))
	((eq pr_fl "10") (setq fil ugnd))
	((eq pr_fl "11") (setq fil uggrd))
	((eq pr_fl "12") (setq fil uggrkd))
	((eq pr_fl "13") (setq fil uggnd))
	((eq pr_fl "14") (setq fil uggnkd))
	((eq pr_fl "15") (setq fil trkvd))
	((eq pr_fl "16") (setq fil trpud))
      ) ;_ end of cond
    ) ;_ end of defun


    (defun desk_f ()
      (setq x	(open (name_fil) "r")
	    a	(read-line x)
	    aa	(read a)
	    b	(read-line x)
	    bb	(read b)
	    aaa	(nth 0 bb)
	    bbb	(nth 9 bb)
      ) ;_ end of setq
    ) ;_ end of defun
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    (setq sortam
	   '("   26020-83    "
	     "    20-93    "
	     "   8239-89     "
	     "   19425-74     "
	     "   19425-74     "
	     "   8240-97     "
	     "   8240-97    ."
	     "    8278-83 . "
	     "    8278-83 . "
	     "   8509-93 "
	     "   8510-86 "
	     "    19771-93  . "
	     "    19771-93  . "
	     "    19772-93  . "
	     "    19772-93  . "
	     "       30245-03"
	     "       30245-03")
    ) ;_  setq
    (start_list "prfl")
    (mapcar 'add_list sortam)
    (end_list)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    (defun r_r ()
      (start_list "n")
      (mapcar 'add_list aa)
      (end_list)
    ) ;_ end of defun


    (defun chart ()
      (start_list "sprav")
      (mapcar 'add_list bbb)
      (end_list)
    ) ;_ end of defun
;;;	 2007 Alan ----   ------------------------------------
    (defun clos_x ()
      (close x)
      (desk_f)
    ) ;_ end of defun

    (defun whl ()
      (if (< (atof rr) (atof aaa))
	(clos_x)
      ) ;_ end of if
      (while (/= (atof rr) (atof aaa))
	(setq b	  (read-line x)
	      bb  (read b)
	      aaa (nth 0 bb)
	      bbb (nth 9 bb)
	) ;_ end of setq
      ) ;_ end of while
    ) ;_ end of defun
;;;	 2007 Alan ----   ------------------------------------



    (if	(action_tile "prfl" "")
      (progn
	(setq dlnug "0")
	(mode_tile "glv" 0)
	(mode_tile "glvm" 1)
	(mode_tile "vsz" 1)
	(mode_tile "vszm" 1)
	(mode_tile "vsv" 0)
	(mode_tile "sec" 0)
	(mode_tile "dln_dt" 1)
	(mode_tile "dl_ug" 1)
;;;	 2007 Alan ----   ------------------------------------
;;;	(setq pr_fl "0")
	(if (eq pr_fl nil)
	  (setq pr_fl "0")
	) ;_  if
	(r10)
;;;	 2007 Alan ----------------------------------------
	(set_tile "prfl" pr_fl)
	(sn_def)
	(desk_f)
	(r_r)
;;;	 2007 Alan -----   -----------------------------------
	(if (eq rr nil)
	  (setq rr "0")
	) ;_  if
	(set_tile "n" rr)
	(whl)
;;;	 2007 Alan ----------------------------------------
	(chart)
	(show_im2 (name))
      ) ;_ end of progn
    ) ;_ end of if

    (defun se_sec ()
      (set_tile "sec" "1")
      (sn_def)
    ) ;_ end of defun


;;;    (defun clos_x ()
;;;      (close x)
;;;      (desk_f)
;;;    ) ;_ end of defun
;;;
;;;    (defun whl ()
;;;      (if (< (atof rr) (atof aaa))
;;;	(clos_x)
;;;      ) ;_ end of if
;;;      (while (/= (atof rr) (atof aaa))
;;;	(setq b	  (read-line x)
;;;	      bb  (read b)
;;;	      aaa (nth 0 bb)
;;;	      bbb (nth 9 bb)
;;;	) ;_ end of setq
;;;      ) ;_ end of while
;;;    ) ;_ end of defun

    (defun ukas	()
      (cond
	((and (or (eq glv1 "1")
		  (eq glvm1 "1")
		  (eq vsz1 "1")
		  (eq vszm1 "1")
		  (eq vsv1 "1")
	      ) ;_ end of or
	      (eq sec1 "0")
	      (eq dlnug "1")
	 ) ;_ end of and
	 (progn (mode_tile "dln_dt" 1) (mode_tile "ug_dt" 1))
	)
	((and (or (eq glv1 "1")
		  (eq glvm1 "1")
		  (eq vsz1 "1")
		  (eq vszm1 "1")
		  (eq vsv1 "1")
	      ) ;_ end of or
	      (eq sec1 "0")
	      (eq dlnug "0")
	 ) ;_ end of and
	 (progn (mode_tile "dln_dt" 0) (mode_tile "ug_dt" 0))
	)
	((and (or (eq glv1 "0")
		  (eq glvm1 "0")
		  (eq vsz1 "0")
		  (eq vszm1 "0")
		  (eq vsv1 "0")
	      ) ;_ end of or
	      (eq sec1 "1")
	      (eq dlnug "1")
	 ) ;_ end of and
	 (progn (mode_tile "dln_dt" 1) (mode_tile "ug_dt" 1))
	)
	((and (or (eq glv1 "0")
		  (eq glvm1 "0")
		  (eq vsz1 "0")
		  (eq vszm1 "0")
		  (eq vsv1 "0")
	      ) ;_ end of or
	      (eq sec1 "1")
	      (eq dlnug "0")
	 ) ;_ end of and
	 (progn (mode_tile "dln_dt" 1) (mode_tile "ug_dt" 0))
	)
      ) ;_ end of cond
    ) ;_ end of defun

    (defun hlp ()
      (set_tile "help" ": >>>")
    ) ;_ end of defun


    (action_tile
      "prfl"
      (strcat
	"(progn (setq pr_fl (get_tile \"prfl\"))"
	"(se_sec)"		    "(desk_f)"
	"(r_r)"			    "(chart)"
	"(show_im2 (name)))"	    "(r10)"
	"(ukas)"		    "(mode_tile \"dl_ug\" 1)"
;;;	 2007 Alan -----   -----------------------------------
	"(set_tile \"n\" \"0\")"
;;;	 2007 Alan ----------------------------------------
	"(hlp)"
       ) ;_  strcat
 ;_  strcat
 ;_ end of strcat
    ) ;_ end of action_tile


    (action_tile
      "n"
      (strcat
	"(progn (setq rr (get_tile \"n\"))"
	"(whl)"
	"(chart))"
	"(hlp)"
      ) ;_ end of strcat
    ) ;_ end of action_tile

    (defun sel_view ()
      (setq rr	  (get_tile "n")
	    vsv1  (get_tile "vsv")
	    glv1  (get_tile "glv")
	    glvm1 (get_tile "glvm")
	    vsz1  (get_tile "vsz")
	    vszm1 (get_tile "vszm")
	    sec1  (get_tile "sec")
      ) ;_ end of setq
;;;	 2007 Alan -----   -----------------------------------
      (whl)
;;;	 2007 Alan -----   -----------------------------------
    ) ;_ end of defun



    (action_tile
      "glv"
      (strcat
	"(progn (sel_view)"
	"(show_im2 (name)))"
	"(ukas)"
	"(mode_tile \"dl_ug\" 0)"
      ) ;_ end of strcat 
    ) ;_ end of action_tile

    (action_tile
      "glvm"
      (strcat
	"(progn (sel_view)"
	"(show_im2 (name)))"
	"(ukas)"
	"(mode_tile \"dl_ug\" 0)"
      ) ;_ end of strcat
    ) ;_ end of action_tile

    (action_tile
      "vsz"
      (strcat
	"(progn (sel_view)"
	"(show_im2 (name)))"
	"(ukas)"
	"(mode_tile \"dl_ug\" 0)"
      ) ;_ end of strcat
    ) ;_ end of action_tile

    (action_tile
      "vszm"
      (strcat
	"(progn (sel_view)"
	"(show_im2 (name)))"
	"(ukas)"
	"(mode_tile \"dl_ug\" 0)"
      ) ;_ end of strcat
    ) ;_ end of action_tile

    (action_tile
      "vsv"
      (strcat
	"(progn (sel_view)"
	"(show_im2 (name)))"
	"(ukas)"
	"(mode_tile \"dl_ug\" 0)"
      ) ;_ end of strcat
    ) ;_ end of action_tile

    (action_tile
      "sec"
      (strcat
	"(progn (sel_view)"
	"(show_im2 (name)))"
	"(ukas)"
	"(mode_tile \"dl_ug\" 1)"
      ) ;_ end of strcat
    ) ;_ end of action_tile


    (if	(action_tile "dln_dt" "")
      (setq dlndt "500")
    ) ;_ end of if

    (action_tile
      "dl_ug"
      (strcat
	"(setq dlnug (get_tile \"dl_ug\"))"
	"(ukas)"
      ) ;_ end of strcat
    ) ;_ end of action_tile

    (action_tile
      "dln_dt"
      "(setq dlndt (get_tile \"dln_dt\"))"
    ) ;_ end of action_tile

    (defun notes ()
      (cond
	((and (or (eq pr_fl "0")
		  (eq pr_fl "1")
		  (eq pr_fl "2")
		  (eq pr_fl "5")
		  (eq pr_fl "6")
		  (eq pr_fl "7")
		  (eq pr_fl "8")
		  (eq pr_fl "9")
		  (eq pr_fl "10")
		  (eq pr_fl "11")
		  (eq pr_fl "12")
		  (eq pr_fl "13")
		  (eq pr_fl "14")
		  (eq pr_fl "15")
		  (eq pr_fl "16")
		  (eq pr_fl "3")
		  (eq pr_fl "4")
	      ) ;_ end of or
	      (eq spr "0")
	 ) ;_ end of and
	 (set_tile "help" " 1 .. ")
	)
	((and (or (eq pr_fl "0")
		  (eq pr_fl "1")
		  (eq pr_fl "2")
		  (eq pr_fl "5")
		  (eq pr_fl "6")
		  (eq pr_fl "7")
		  (eq pr_fl "8")
		  (eq pr_fl "16")
		  (eq pr_fl "3")
		  (eq pr_fl "4")
	      ) ;_ end of or
	      (eq spr "1")
	 ) ;_ end of and
	 (set_tile "help" " ")
	)
	((or (and (eq pr_fl "15")
		  (eq spr "1")
	     ) ;_ end of and
	     (and (eq pr_fl "16") (eq spr "2"))
	 ) ;_ end of or
	 (set_tile "help" " ")
	)
	((or (and (or (eq pr_fl "0")
		      (eq pr_fl "1")
		      (eq pr_fl "2")
		      (eq pr_fl "5")
		      (eq pr_fl "6")
		      (eq pr_fl "7")
		      (eq pr_fl "8")
		      (eq pr_fl "3")
		      (eq pr_fl "4")
		  ) ;_ end of or
		  (eq spr "2")
	     ) ;_ end of and
	     (and (or (eq pr_fl "9") (eq pr_fl "11") (eq pr_fl "12"))
		  (eq spr "1")
	     ) ;_  and
	 ) ;_ end of or
	 (set_tile "help" " ")
	)
	((and (or (eq pr_fl "10") (eq pr_fl "13") (eq pr_fl "14"))
	      (eq spr "1")
	 ) ;_  and
	 (set_tile "help" "  ")
	)
	((and (or (eq pr_fl "10") (eq pr_fl "13") (eq pr_fl "14"))
	      (eq spr "2")
	 ) ;_  and
	 (set_tile "help" "  ")
	)
	((or (and (or (eq pr_fl "0")
		      (eq pr_fl "1")
		      (eq pr_fl "2")
		      (eq pr_fl "5")
		      (eq pr_fl "6")
		      (eq pr_fl "16")
		      (eq pr_fl "3")
		      (eq pr_fl "4")
		  ) ;_ end of or
		  (eq spr "3")
	     ) ;_ end of and
	     (and (eq pr_fl "15") (eq spr "2"))
	 ) ;_ end of or
	 (set_tile "help" " ")
	)
	((or (and (eq pr_fl "15")
		  (eq spr "3")
	     ) ;_ end of and
	     (and (eq pr_fl "16") (eq spr "4"))
	 ) ;_ end of or
	 (set_tile "help"
		   "    < >"
	 ) ;_  set_tile
	)
	((and (or (eq pr_fl "2")
		  (eq pr_fl "3")
		  (eq pr_fl "4")
		  (eq pr_fl "5")
	      ) ;_  or
	      (eq spr "4")
	 ) ;_  and
	 (set_tile "help" "  ")
	)
	((or (and (or (eq pr_fl "7")
		      (eq pr_fl "8")
		      (eq pr_fl "13")
		      (eq pr_fl "14")
		  ) ;_  or
		  (eq spr "4")
	     ) ;_  and
	     (and (or (eq pr_fl "11") (eq pr_fl "12")) (eq spr "3"))
	 ) ;_ end of or
	 (set_tile "help" "   < >")
	)
	((or (and (or (eq pr_fl "7") (eq pr_fl "8")) (eq spr "5"))
	     (and (or (eq pr_fl "11") (eq pr_fl "12")) (eq spr "4"))
	 ) ;_ end of or
	 (set_tile
	   "help"
	   "n = (b - s - R) / s -  .    s "
	 ) ;_ end of set_tile
	)
	((and (or (eq pr_fl "13") (eq pr_fl "14")) (eq spr "5"))
	 (set_tile
	   "help"
	   "n1 = (B - s - R) / s -  .    s "
	 ) ;_ end of set_tile
	)
	((and (or (eq pr_fl "13") (eq pr_fl "14")) (eq spr "6"))
	 (set_tile
	   "help"
	   "n2 = (b - s - R) / s -  .    s "
	 ) ;_ end of set_tile
	)
	((and (or (eq pr_fl "7") (eq pr_fl "8")) (eq spr "6"))
	 (set_tile
	   "help"
	   "n1 = (h - 2(R + s)) / s -  .   s "
	 ) ;_ end of set_tile
	)
	((or (and (or (eq pr_fl "0") (eq pr_fl "1") (eq pr_fl "6"))
		  (eq spr "4")
	     ) ;_  and
	     (and (or (eq pr_fl "9") (eq pr_fl "11") (eq pr_fl "12"))
		  (eq spr "2")
	     ) ;_  and
	     (and (or (eq pr_fl "7")
		      (eq pr_fl "8")
		      (eq pr_fl "10")
		      (eq pr_fl "13")
		      (eq pr_fl "14")
		  ) ;_  or
		  (eq spr "3")
	     ) ;_ end of and
	 ) ;_ end of or
	 (set_tile "help" " ")
	)
	((and (or (eq pr_fl "0")
		  (eq pr_fl "1")
		  (eq pr_fl "2")
		  (eq pr_fl "5")
		  (eq pr_fl "6")
		  (eq pr_fl "3")
		  (eq pr_fl "4")
	      ) ;_  or
	      (eq spr "5")
	 ) ;_ end of and
	 (set_tile "help" "    ")
	)
	((or (and (eq pr_fl "9") (eq spr "3"))
	     (and (eq pr_fl "10") (eq spr "4"))
	 ) ;_ end of or
	 (set_tile "help" "  ")
	)
	((or (and (or (eq pr_fl "0")
		      (eq pr_fl "1")
		      (eq pr_fl "2")
		      (eq pr_fl "5")
		      (eq pr_fl "6")
		      (eq pr_fl "3")
		      (eq pr_fl "4")
		  ) ;_  or
		  (eq spr "6")
	     ) ;_ end of and
	     (and (eq pr_fl "9") (eq spr "4"))
	     (and (eq pr_fl "10") (eq spr "5"))
	 ) ;_ end of or
	 (set_tile "help" "  ")
	)
	((or (and (or (eq pr_fl "0")
		      (eq pr_fl "1")
		      (eq pr_fl "2")
		      (eq pr_fl "5")
		      (eq pr_fl "6")
		      (eq pr_fl "7")
		      (eq pr_fl "8")
		      (eq pr_fl "13")
		      (eq pr_fl "14")
		      (eq pr_fl "3")
		      (eq pr_fl "4")
		  ) ;_ end of or
		  (eq spr "7")
	     ) ;_ end of and
	     (and (or (eq pr_fl "9")
		      (eq pr_fl "11")
		      (eq pr_fl "12")
		      (eq pr_fl "16")
		  ) ;_  or
		  (eq spr "5")
	     ) ;_  and
	     (and (eq pr_fl "10") (eq spr "6"))
	     (and (eq pr_fl "15") (eq spr "4"))
	     (and (eq pr_fl "16") (eq spr "5"))
	 ) ;_ end of or
	 (set_tile "help" "  ")
	)
	((or (and (or (eq pr_fl "0")
		      (eq pr_fl "1")
		      (eq pr_fl "2")
		      (eq pr_fl "5")
		      (eq pr_fl "6")
		      (eq pr_fl "7")
		      (eq pr_fl "8")
		      (eq pr_fl "13")
		      (eq pr_fl "14")
		      (eq pr_fl "3")
		      (eq pr_fl "4")
		  ) ;_ end of or
		  (eq spr "8")
	     ) ;_ end of and
	     (and (or (eq pr_fl "9") (eq pr_fl "11") (eq pr_fl "12"))
		  (eq spr "6")
	     ) ;_  and
	     (and (eq pr_fl "10") (eq spr "7"))
	     (and (eq pr_fl "15") (eq spr "5"))
	     (and (eq pr_fl "16") (eq spr "6"))
	 ) ;_ end of or
	 (set_tile "help" "    -")
	)
	((or (and (eq pr_fl "9") (eq spr "8")) ;_ end of and 
	     (and (or (eq pr_fl "11") (eq pr_fl "12")) (eq spr "10")) ;_ end of and 
	     (and (or (eq pr_fl "13") (eq pr_fl "14")) (eq spr "16")) ;_ end of and 
	 ) ;_ end of or
	 (set_tile "help" "    o-o")
	)
	((or (and (eq pr_fl "9") (eq spr "9")) ;_ end of and 
	     (and (or (eq pr_fl "11") (eq pr_fl "12")) (eq spr "11")) ;_ end of and 
	     (and (or (eq pr_fl "13") (eq pr_fl "14")) (eq spr "17")) ;_ end of and 
	 ) ;_ end of or
	 (set_tile "help" "    o-o")
	)
	((or (and (eq pr_fl "9") (eq spr "10")) ;_ end of and 
	     (and (or (eq pr_fl "11") (eq pr_fl "12")) (eq spr "12")) ;_ end of and
	     (and (or (eq pr_fl "13") (eq pr_fl "14")) (eq spr "18")) ;_ end of and 
	 ) ;_ end of or
	 (set_tile "help" "    Yo-Yo")
	)
	((and (eq pr_fl "10") (eq spr "13")) ;_ end of and  
	 (set_tile "help" "    Y1-Y1(min)")
	)
	((and (eq pr_fl "10") (eq spr "15")) ;_ end of and  
	 (set_tile "help" "    U-U(min)")
	)
	((or (and (eq pr_fl "9") (eq spr "11")) ;_ end of and 
	     (and (or (eq pr_fl "11") (eq pr_fl "12")) (eq spr "13")) ;_ end of and  
	     (and (or (eq pr_fl "13") (eq pr_fl "14")) (eq spr "19")) ;_ end of and 
	 ) ;_ end of or
	 (set_tile "help" "    Yo-Yo")
	)
	((and (eq pr_fl "10") (eq spr "16")) ;_ end of and  
	 (set_tile "help" "    U-U(min)")
	)
	((and (eq pr_fl "10") (eq spr "17")) ;_ end of and  
	 (set_tile "help" "    U-U")
	)
	((and (or (eq pr_fl "13") (eq pr_fl "14")) (eq spr "20")) ;_ end of and  
	 (set_tile "help" "    Yo-Yo")
	)
	((or (and (or (eq pr_fl "9") (eq pr_fl "13") (eq pr_fl "14"))
		  (eq spr "12")
	     ) ;_ end of and
	     (and (eq pr_fl "10") (eq spr "11"))
	     (and (or (eq pr_fl "11") (eq pr_fl "12")) (eq spr "14")) ;_ end of and 
	 ) ;_end of or 
	 (set_tile "help" "    X1-X1")
	)
	((or (and (or (eq pr_fl "11") (eq pr_fl "12")) (eq spr "15")) ;_ end of and
	     (and (or (eq pr_fl "13") (eq pr_fl "14")) (eq spr "14")) ;_ end of and
	 ) ;_ end of or
	 (set_tile "help" "    Y1-Y1")
	)
	((or (and (eq pr_fl "9") (eq spr "13")) ;_ end of and
	     (and (eq pr_fl "10") (eq spr "12"))
	     (and (eq pr_fl "10") (eq spr "14"))
	     (and (or (eq pr_fl "11") (eq pr_fl "12"))
		  (or (eq spr "16") (eq spr "17"))
	     ) ;_ end of and
	     (and (or (eq pr_fl "13") (eq pr_fl "14"))
		  (or (eq spr "13") (eq spr "15"))
	     ) ;_  and
	 ) ;_end of or  
	 (set_tile "help"
		   "       "
	 ) ;_ end of set_tile
	)
	((or (and (or (eq pr_fl "0")
		      (eq pr_fl "1")
		      (eq pr_fl "2")
		      (eq pr_fl "5")
		      (eq pr_fl "6")
		      (eq pr_fl "7")
		      (eq pr_fl "8")
		      (eq pr_fl "3")
		      (eq pr_fl "4")
		  ) ;_ end of or
		  (eq spr "9")
	     ) ;_ end of and
	     (and (eq pr_fl "15") (eq spr "7"))
	     (and (eq pr_fl "16") (eq spr "8"))
	 ) ;_end of or
	 (set_tile "help" "    -")
	)
	((or (and (or (eq pr_fl "0")
		      (eq pr_fl "1")
		      (eq pr_fl "2")
		      (eq pr_fl "5")
		      (eq pr_fl "6")
		      (eq pr_fl "7")
		      (eq pr_fl "8")
		      (eq pr_fl "3")
		      (eq pr_fl "4")
		  ) ;_ end of or
		  (eq spr "10")
	     ) ;_ end of and
	     (and (eq pr_fl "9") (eq spr "7"))
	     (and (eq pr_fl "16") (eq spr "10"))
	     (and (or (eq pr_fl "13") (eq pr_fl "14") (eq pr_fl "15"))
		  (eq spr "9")
	     ) ;_  and
	     (and (or (eq pr_fl "10") (eq pr_fl "11") (eq pr_fl "12"))
		  (eq spr "8")
	     ) ;_  and
	 ) ;_ end of or
	 (set_tile "help" "    -")
	)
	((and (or (eq pr_fl "0")
		  (eq pr_fl "1")
		  (eq pr_fl "2")
		  (eq pr_fl "5")
		  (eq pr_fl "6")
		  (eq pr_fl "7")
		  (eq pr_fl "8")
		  (eq pr_fl "3")
		  (eq pr_fl "4")
	      ) ;_ end of or
	      (eq spr "11")
	 ) ;_ end of and
	 (set_tile "help"
		   "     -"
	 ) ;_ end of set_tile
	)
	((or (and (or (eq pr_fl "0")
		      (eq pr_fl "1")
		      (eq pr_fl "2")
		      (eq pr_fl "5")
		      (eq pr_fl "6")
		      (eq pr_fl "7")
		      (eq pr_fl "8")
		      (eq pr_fl "3")
		      (eq pr_fl "4")
		  ) ;_ end of or
		  (eq spr "12")
	     ) ;_ end of and 
	     (and (eq pr_fl "10") (eq spr "9"))
	     (and (or (eq pr_fl "11") (eq pr_fl "12") (eq pr_fl "16"))
		  (eq spr "7")
	     ) ;_  and
	     (and (or (eq pr_fl "13") (eq pr_fl "14")) (eq spr "10"))
	     (and (eq pr_fl "15") (eq spr "6"))
	 ) ;_end of or
	 (set_tile "help" "    Y-Y")
	)
	((or (and (or (eq pr_fl "0")
		      (eq pr_fl "1")
		      (eq pr_fl "2")
		      (eq pr_fl "5")
		      (eq pr_fl "6")
		      (eq pr_fl "7")
		      (eq pr_fl "8")
		      (eq pr_fl "3")
		      (eq pr_fl "4")
		  ) ;_ end of or
		  (eq spr "13")
	     ) ;_ end of and
	     (and (eq pr_fl "15") (eq spr "8"))
	     (and (eq pr_fl "16") (eq spr "9"))
	 ) ;_end of or
	 (set_tile "help" "    Y-Y")
	)
	((or (and (or (eq pr_fl "0")
		      (eq pr_fl "1")
		      (eq pr_fl "2")
		      (eq pr_fl "5")
		      (eq pr_fl "6")
		      (eq pr_fl "7")
		      (eq pr_fl "8")
		      (eq pr_fl "3")
		      (eq pr_fl "4")
		  ) ;_ end of or
		  (eq spr "14")
	     ) ;_ end of and
	     (and (eq pr_fl "10") (eq spr "10"))
	     (and (or (eq pr_fl "11") (eq pr_fl "12")) (eq spr "9"))
	     (and (or (eq pr_fl "13") (eq pr_fl "14")) (eq spr "11"))
	     (and (eq pr_fl "15") (eq spr "10"))
	     (and (eq pr_fl "16") (eq spr "11"))
	 ) ;_end of or
	 (set_tile "help" "    Y-Y")
	)
	((and (or (eq pr_fl "5")
		  (eq pr_fl "6")
		  (eq pr_fl "7")
		  (eq pr_fl "8")
	      ) ;_  or
	      (eq spr "15")
	 ) ;_ end of and
	 (set_tile "help"
		   "   Y-Y    "
	 ) ;_ end of set_tile
	)
      ) ;_ end of cond
    ) ;_ end of defun

    (action_tile
      "sprav"
      (strcat
	"(setq spr (get_tile \"sprav\"))"
	"(notes)"
      ) ;_ end of strcat
    ) ;_ end of action_tile




    (action_tile	      ;  
      "accept"		      ;   


      (strcat "(progn (setq rr (get_tile \"n\"))"

	      "(done_dialog))"
	      "(close x)"
      ) ;_ end of strcat
    )			      ; , 
			      ;  
    (action_tile
      "cancel"
      (strcat "(progn (setq rr nil)" "(done_dialog))" "(close x)")
    ) ;_ end of action_tile


    (start_dialog)	      ;  


    (unload_dialog dcl_id)    ; DCL-
    (prin1)
  )			      ;   show 
  (show)
  (cond
    ((and (eq pr_fl "0") (/= rr nil))
     (dv_t_rp)
    )
    ((and (eq pr_fl "1") (/= rr nil))
     (dv_t_rp)
    )
    ((and (or (eq pr_fl "2") (eq pr_fl "3"))
	  (/= rr nil)
     ) ;_  and
     (dv_t_r)
    )
    ((and (or (eq pr_fl "5") (eq pr_fl "4")) (/= rr nil))
     (sv_l_r)
    )
    ((and (eq pr_fl "6") (/= rr nil))
     (sv_l_rp)
    )
    ((and (eq pr_fl "7") (/= rr nil))
     (sv_l_rg)
    )
    ((and (eq pr_fl "8") (/= rr nil))
     (sv_l_rg)
    )
    ((and (eq pr_fl "9") (/= rr nil))
     (ug_rp)
    )
    ((and (eq pr_fl "10") (/= rr nil))
     (ug_np)
    )
    ((and (eq pr_fl "11") (/= rr nil))
     (ug_rg)
    )
    ((and (eq pr_fl "12") (/= rr nil))
     (ug_rg)
    )
    ((and (eq pr_fl "13") (/= rr nil))
     (ug_ng)
    )
    ((and (eq pr_fl "14") (/= rr nil))
     (ug_ng)
    )
    ((and (eq pr_fl "15") (/= rr nil))
     (tr_prf)
    )
    ((and (eq pr_fl "16") (/= rr nil))
     (tr_prf)
    )
  ) ;_ end of cond

  (prin1)

) ;_ end of defun



;|Visual LISP Format Options
(72 2 30 2 T " " 72 9 1 1 0 T T nil T)
;***     ! ***|;
