

;;; 

(defun sv_l_rp (/      cmd    blpm   apsz   osmd   cpt	  ept	 hsvp
		bsvp   hp1p   hp2p   hp3p   lp1p   rd1p	  rd2p	 sset
		label  edat3  pt1    pt2    pt3	   pt4	  pt5	 pt6
		pt7    pt8    pt9    pt10   pt11   clay	  cltp	 ccol
	       )

  (setq cmd (getvar "cmdecho"))
  (setq blpm (getvar "blipmode"))
  (setq apsz (getvar "aperture"))
  (setq osmd (getvar "osmode"))
  (setq clay (getvar "clayer"))
  (setq cltp (getvar "celtype"))
  (setq ccol (getvar "cecolor"))
  (setvar "cmdecho" 0)
  (setvar "blipmode" 0)

  (setq	hsvp (nth 1 bb)
	bsvp (nth 2 bb)
	hp1p (nth 3 bb)
	hp2p (nth 4 bb)
	hp3p (nth 5 bb)
	lp1p (nth 6 bb)
	rd1p (nth 7 bb)
	rd2p (nth 8 bb)
  ) ;_ end of setq


  (defun lay_o ()
    (command "_'layer" "_s" "0" "")
  ) ;_ end of defun
  (lay_o)

  (if (eq sec1 "0")
    (if	(eq dlnug "1")
      (progn
	(initget 1)
	(setq cpt (getpoint "\n First point:"))
	(initget 1)
	(setq ept (polar cpt 0 (getdist cpt "\n Second point:")))
	(setq dlndt (itoa (fix (distance cpt ept))))
      ) ;_ end of progn
      (setq cpt	'(0.0 0.0)
	    ept	(polar cpt 0 (read dlndt))
      ) ;_ end of setq
    ) ;_ end of if
  ) ;_ end of if

  (defun ris_shrp ()

;;;     


    (defun shv_gl_szp ()

      (setq pt3	(polar cpt (/ pi 2) hsvp)
	    pt4	(polar ept (/ pi 2) hsvp)
	    pt5	(polar cpt (/ pi 2) hp1p)
	    pt7	(polar cpt (/ pi 2) hp2p)
	    pt6	(polar ept (/ pi 2) hp1p)
	    pt8	(polar ept (/ pi 2) hp2p)
      ) ;_ end of setq

      (setvar "osmode" 0)
      (setvar "aperture" 1)
      (command "_linetype" "_s" "_bylayer" "")
      (command "_color" "_byl")
      (command "_line" cpt ept "")
      (setq label (entlast))
      (setq sset (ssadd (entlast)))

      (command "_line" ept pt4 pt3 cpt "")
      (if (eq vsz1 "1")
	(progn
	  (setvar "celtype" "ACAD_ISO02W100")
	  (command "_color" "1")
	) ;_  progn
	(progn
	  (command "_linetype" "_s" "_bylayer" "")
	  (command "_color" "_byl")
	) ;_  progn
      ) ;_ end of if
      (command "_line" pt5 pt6 "")
      (command "_line" pt7 pt8 "")


    ) ;_ end of defun

;;;  

    (defun shv_v_svp ()

      (setq pt3	(polar cpt (/ pi 2) bsvp)
	    pt4	(polar ept (/ pi 2) bsvp)
	    pt5	(polar pt3 (/ (* pi 3) 2) hp3p)
	    pt6	(polar pt4 (/ (* pi 3) 2) hp3p)
      ) ;_ end of setq

      (setvar "osmode" 0)
      (setvar "aperture" 1)
      (command "_linetype" "_s" "_bylayer" "")
      (command "_color" "_byl")
      (command "_line" cpt ept "")
      (setq label (entlast))
      (setq sset (ssadd (entlast)))
      (command "_line" ept pt4 pt3 cpt "")

      (setvar "celtype" "ACAD_ISO02W100")
      (command "_color" "1")
      (command "_line" pt5 pt6 "")

    )			      ;    shv_v_svp

;;; 

    (defun shv_scp ()

      (setq cpt '(0.0 0.0))

      (setvar "osmode" 0)
      (setvar "aperture" 1)
      (setq pt1 (polar cpt 0 bsvp))
      (setq pt11 (polar cpt (/ pi 2) hsvp))
      (setq pt10 (polar pt11 0 bsvp))
      (setq pt2 (polar pt1 (/ pi 2) lp1p))
      (setq pt9 (polar pt10 (/ (* pi 3) 2) lp1p))
      (setq pt8	(polar pt9
		       (/ (* pi 5) 4)
		       (* rd1p (sqrt 2.0000))
		) ;_ end of polar
      ) ;_ end of setq
      (setq pt3	(polar pt2
		       (/ (* pi 3) 4)
		       (* rd1p (sqrt 2.0000))
		) ;_ end of polar
      ) ;_ end of setq
      (setq pt4
	     (polar pt3
		    pi
		    (- (- (- bsvp hp3p) rd1p) rd2p)
	     ) ;_ end of polar
      ) ;_ end of setq
      (setq pt7
	     (polar pt8
		    pi
		    (- (- (- bsvp hp3p) rd1p) rd2p)
	     ) ;_ end of polar
      ) ;_ end of setq
      (setq pt5	(polar pt4
		       (/ (* pi 3) 4)
		       (* rd2p (sqrt 2.0000))
		) ;_ end of polar
      ) ;_ end of setq
      (setq pt6	(polar pt7
		       (/ (* pi 5) 4)
		       (* rd2p (sqrt 2.0000))
		) ;_ end of polar
      ) ;_ end of setq


      (command "_linetype" "_s" "_bylayer" "")
      (command "_color" "_byl")

      (command "_line" pt2 pt1 "")
      (setq label (entlast))
      (setq sset (ssadd (entlast)))


      (command "_line" pt1 cpt pt11 pt10 pt9 "")
      (command "_arc" pt8 "_e" pt9 "_r" rd1p)
      (command "_arc" pt2 "_e" pt3 "_r" rd1p)
      (command "_line" pt8 pt7 "")
      (command "_line" pt3 pt4 "")
      (command "_arc" pt5 "_e" pt4 "_r" rd2p)
      (command "_arc" pt7 "_e" pt6 "_r" rd2p)
      (command "_line" pt5 pt6 "")

    )			      ;    shv_scp

    (cond ((or (= glv1 "1") (= vsz1 "1")) (shv_gl_szp))
	  ((= vsv1 "1") (shv_v_svp))
	  ((= sec1 "1") (shv_scp))
    ) ;_ end of cond

    (setvar "cmdecho" cmd)
    (setvar "blipmode" blpm)


    (while (setq label (entnext label))
      (setq sset (ssadd label sset))
    ) ;_ end of while

  ) ;_end of defun RIS_SHRP

  (defun edat ()
    (cond ((eq glv1 "1") (setq nmpr "A"))
	  ((eq vsz1 "1") (setq nmpr "C"))
	  ((eq vsv1 "1") (setq nmpr "E"))
	  ((eq sec1 "1") (setq nmpr "F"))
    ) ;_  cond
    (setq edat3 (strcat "C" nmpr pr_fl rr dlndt))
  ) ;_ end of defun

  (defun clip_bl ()
    (edat)
    (if	(eq (tblsearch "block" edat3) nil)
      (progn
	(ris_shrp)
	(command "._block" edat3 cpt sset "")
	(setvar "aperture" apsz)
	(setvar "osmode" osmd)
	(setvar "clayer" clay)
	(command "._insert" edat3 pause 1 1 pause)
      ) ;_ end of progn
      (progn
	(setvar "clayer" clay)
	(command "._insert" edat3 pause 1 1 pause)
      ) ;_ end of progn
    ) ;_end of if
    (setvar "celtype" cltp)
    (setvar "cecolor" ccol)
  ) ;_ end of defun CLIP_BL

  (clip_bl)
  (prin1)

)			      ;    SV_L_RP
;|Visual LISP Format Options
(72 2 30 2 T " " 72 9 1 1 0 T T nil T)
;***     ! ***|;
