

;;;    

(defun tr_prf (/     cmd   blpm	 apsz  osmd  cpt   ept	 btr   htr
	       str   rd1   sset	 label edat3 pt1   pt2	 pt3   pt4
	       pt5   pt6   pt7	 pt8   pt9   pt10  pt11	 pt12  pt13
	       pt14  pt15  pt16	 clay  cltp  ccol
	      )

  (setq cmd (getvar "cmdecho"))
  (setq blpm (getvar "blipmode"))
  (setq apsz (getvar "aperture"))
  (setq osmd (getvar "osmode"))
  (setq clay (getvar "clayer"))
  (setq cltp (getvar "celtype"))
  (setq ccol (getvar "cecolor"))
  (setvar "cmdecho" 0)
  (setvar "blipmode" 0)

  (setq	htr (nth 1 bb)
	btr (nth 2 bb)
	str (nth 3 bb)
	rd1 (if	(<= str 6.0)
	      (* str 2.4)
	      (if (<= str 10)
		(* str 3.0)
		(if (> str 10)
		  (* str 3.6)
		) ;_  if
	      ) ;_  if
	    ) ;_  if
  ) ;_ end of setq

  (defun lay_o ()
    (command "_'layer" "_s" "0" "")
  ) ;_ end of defun

  (lay_o)

  (if (eq sec1 "0")
    (if	(eq dlnug "1")
      (progn
	(initget 1)
	(setq cpt (getpoint "\n First point:"))
	(initget 1)
	(setq ept (polar cpt 0 (getdist cpt "\n Second point:")))
	(setq dlndt (itoa (fix (distance cpt ept))))
      ) ;_ end of progn
      (setq cpt	'(0.0 0.0)
	    ept	(polar cpt 0 (read dlndt))
      ) ;_ end of setq
    ) ;_ end of if
  ) ;_ end of if

  (defun ris_trprf ()

;;;   


    (defun trprf_gl_sz ()


      (setq pt3	(polar cpt (/ pi 2) htr)
	    pt4	(polar ept (/ pi 2) htr)
	    pt5	(polar cpt (/ pi 2) str)
	    pt6	(polar ept (/ pi 2) str)
	    pt7	(polar cpt (/ pi 2) (- htr str))
	    pt8	(polar ept (/ pi 2) (- htr str))
      ) ;_ end of setq

      (setvar "osmode" 0)
      (setvar "aperture" 1)
      (command "_linetype" "_s" "bylayer" "")
      (command "_color" "_byl")
      (command "_line" cpt ept "")
      (setq label (entlast))
      (setq sset (ssadd (entlast)))

      (command "_line" ept pt4 pt3 cpt "")
      (if (eq glv1 "1")
	(progn
	  (setvar "celtype" "ACAD_ISO02W100")
	  (command "_color" "1")
	) ;_  progn
	(progn
	  (command "_linetype" "_s" "bylayer" "")
	  (command "_color" "_byl")
	) ;_  progn
      ) ;_ end of if
      (command "_line" pt5 pt6 "" "_line" pt7 pt8 "") ;_  command

    ) ;_ end of defun

;;;   

    (defun trprf_v_sv ()

      (setq pt3	(polar cpt (/ pi 2) btr)
	    pt4	(polar ept (/ pi 2) btr)
	    pt5	(polar cpt (/ pi 2) str)
	    pt6	(polar ept (/ pi 2) str)
	    pt7	(polar cpt (/ pi 2) (- btr str))
	    pt8	(polar ept (/ pi 2) (- btr str))
      ) ;_ end of setq

      (setvar "osmode" 0)
      (setvar "aperture" 1)
      (command "_linetype" "_s" "bylayer" "")
      (command "_color" "_byl")
      (command "_line" cpt ept "")
      (setq label (entlast))
      (setq sset (ssadd (entlast)))
      (command "_line" ept pt4 pt3 cpt "")

      (if (eq vsv1 "1")
	(progn
	  (setvar "celtype" "ACAD_ISO02W100")
	  (command "_color" "1")
	) ;_  progn
	(progn
	  (command "_linetype" "_s" "bylayer" "")
	  (command "_color" "_byl")
	) ;_  progn
      ) ;_ end of if
      (command "_line" pt5 pt6 "" "_line" pt7 pt8 "") ;_  command
    )			      ;   trprf_v_sv


;;; 

    (defun trprf_sc ()

      (setq cpt '(0.0 0.0))

      (setvar "osmode" 0)
      (setvar "aperture" 1)
      (setq pt1	 (polar cpt 0 rd1)
	    pt2	 (polar cpt 0 (- btr rd1))
	    pt3	 (polar pt1 (/ pi 2) str)
	    pt4	 (polar pt2 (/ pi 2) str)
	    pt5	 (polar cpt (/ pi 2) rd1)
	    pt6	 (polar cpt (/ pi 2) (- htr rd1))
	    pt7	 (polar pt5 0 str)
	    pt8	 (polar pt6 0 str)
	    pt9	 (polar pt1 (/ pi 2) htr)
	    pt10 (polar pt2 (/ pi 2) htr)
	    pt11 (polar pt1 (/ pi 2) (- htr str))
	    pt12 (polar pt2 (/ pi 2) (- htr str))
	    pt13 (polar pt5 0 btr)
	    pt14 (polar pt6 0 btr)
	    pt15 (polar pt5 0 (- btr str))
	    pt16 (polar pt6 0 (- btr str))
      ) ;_ end of setq

      (command "_linetype" "_s" "bylayer" "")
      (command "_color" "_byl")

      (command "_line" pt4 pt3 "")
      (setq label (entlast))
      (setq sset (ssadd (entlast)))


      (command "_line" pt2     pt1     ""      "_line" pt5     pt6
	       ""      "_line" pt7     pt8     ""      "_line" pt9
	       pt10    ""      "_line" pt11    pt12    ""      "_line"
	       pt13    pt14    ""      "_line" pt15    pt16    ""
	      ) ;_  command
 ;_ end of command
      (command "_arc"
	       pt7
	       "_e"
	       pt3
	       "_r"
	       (- rd1 str)
	       "_arc"
	       pt5
	       "_e"
	       pt1
	       "_r"
	       rd1
	       "_arc"
	       pt11
	       "_e"
	       pt8
	       "_r"
	       (- rd1 str)
	       "_arc"
	       pt9
	       "_e"
	       pt6
	       "_r"
	       rd1
	       "_arc"
	       pt16
	       "_e"
	       pt12
	       "_r"
	       (- rd1 str)
	       "_arc"
	       pt14
	       "_e"
	       pt10
	       "_r"
	       rd1
	       "_arc"
	       pt4
	       "_e"
	       pt15
	       "_r"
	       (- rd1 str)
	       "_arc"
	       pt2
	       "_e"
	       pt13
	       "_r"
	       rd1
      ) ;_ end of command

    )			      ;    trprf_sc

    (cond ((= glv1 "1") (trprf_gl_sz))
	  ((= vsv1 "1") (trprf_v_sv))
	  ((= sec1 "1") (trprf_sc))
    ) ;_ end of cond

    (setvar "cmdecho" cmd)
    (setvar "blipmode" blpm)

    (while (setq label (entnext label))
      (setq sset (ssadd label sset))
    ) ;_ end of while

  ) ;_end of defun RIS_trprf

  (defun edat ()
    (cond ((eq glv1 "1") (setq nmpr "A"))
	  ((eq vsv1 "1") (setq nmpr "E"))
	  ((eq sec1 "1") (setq nmpr "F"))
    ) ;_  cond
    (setq edat3 (strcat "TPR" nmpr pr_fl rr dlndt))
  ) ;_ end of defun

  (defun clip_bl ()
    (edat)
    (if	(eq (tblsearch "block" edat3) nil)
      (progn
	(ris_trprf)
	(command "._block" edat3 cpt sset "")
	(setvar "aperture" apsz)
	(setvar "osmode" osmd)
	(setvar "clayer" clay)
	(command "._insert" edat3 pause 1 1 pause)
      ) ;_ end of progn
      (progn
	(setvar "clayer" clay)
	(command "._insert" edat3 pause 1 1 pause)
      ) ;_ end of progn
    ) ;_end of if
    (setvar "celtype" cltp)
    (setvar "cecolor" ccol)
  ) ;_ end of defun CLIP_BL

  (clip_bl)
  (prin1)

)			      ;    tr_prf
;|Visual LISP Format Options
(72 2 30 2 T " " 72 9 1 1 0 T T nil T)
;***     ! ***|;
