

;;;  

(defun ug_rp (/	    cmd	  blpm	apsz  osmd  cpt	  ept	bug   sug
	      lp1   rd1	  rd2	sset  label edat3 pt1	pt2   pt3
	      pt4   pt5	  pt6	pt7   pt8   clay  cltp	ccol
	     )

  (setq cmd (getvar "cmdecho"))
  (setq blpm (getvar "blipmode"))
  (setq apsz (getvar "aperture"))
  (setq osmd (getvar "osmode"))
  (setq clay (getvar "clayer"))
  (setq cltp (getvar "celtype"))
  (setq ccol (getvar "cecolor"))
  (setvar "cmdecho" 0)
  (setvar "blipmode" 0)

  (setq	bug (nth 1 bb)
	sug (nth 2 bb)
	lp1 (nth 3 bb)
	rd2 (nth 4 bb)
	rd1 (nth 5 bb)
  ) ;_ end of setq


  (defun lay_o ()
    (command "_'layer" "_s" "0" "")
  ) ;_ end of defun

  (lay_o)

  (if (eq sec1 "0")
    (if	(eq dlnug "1")
      (progn
	(initget 1)
	(setq cpt (getpoint "\n First point:"))
	(initget 1)
	(setq ept (polar cpt 0 (getdist cpt "\n Second point:")))
	(setq dlndt (itoa (fix (distance cpt ept))))
      ) ;_ end of progn
      (setq cpt	'(0.0 0.0)
	    ept	(polar cpt 0 (read dlndt))
      ) ;_ end of setq
    ) ;_ end of if
  ) ;_ end of if

  (defun ris_ugrp ()

;;;     


    (defun ug_gl_sz ()

      (setq pt3	(polar cpt (/ pi 2) bug)
	    pt4	(polar ept (/ pi 2) bug)
	    pt5	(polar cpt (/ pi 2) sug)
	    pt6	(polar ept (/ pi 2) sug)
      ) ;_ end of setq

      (setvar "osmode" 0)
      (setvar "aperture" 1)
      (command "_linetype" "_s" "_bylayer" "")
      (command "_color" "_byl")
      (command "_line" cpt ept "")
      (setq label (entlast))
      (setq sset (ssadd (entlast)))

      (command "_line" ept pt4 pt3 cpt "")
      (if (eq vsz1 "1")
	(progn
	  (setvar "celtype" "ACAD_ISO02W100")
	  (command "_color" "1")
	) ;_  progn
	(progn
	  (command "_linetype" "_s" "_bylayer" "")
	  (command "_color" "_byl")
	) ;_  progn
      ) ;_ end of if
      (command "_line" pt5 pt6 "")

    ) ;_ end of defun


;;; 

    (defun ug_sc ()

      (setq cpt '(0.0 0.0))

      (setvar "osmode" 0)
      (setvar "aperture" 1)
      (setq pt1	(polar cpt 0 bug)
	    pt8	(polar cpt (/ pi 2) bug)
	    pt7	(polar pt8 0 lp1)
	    pt2	(polar pt1 (/ pi 2) lp1)
	    pt3	(polar pt2 (/ (* pi 3) 4) (* (sqrt 2.0000) rd1))
	    pt6	(polar pt7 (/ (* pi 7) 4) (* (sqrt 2.0000) rd1))
	    pt4	(polar pt3 pi (- bug (+ (+ rd1 rd2) sug)))
	    pt5	(polar pt6 (/ (* pi 3) 2) (- bug (+ (+ rd1 rd2) sug)))
      ) ;_ end of setq

      (command "_linetype" "_s" "_bylayer" "")
      (command "_color" "_byl")

      (command "_line" pt2 pt1 "")
      (setq label (entlast))
      (setq sset (ssadd (entlast)))


      (command "_line" pt7 pt8 cpt pt1 "" "_line" pt3 pt4 "" "_line" pt5
	       pt6 "") ;_  command
 ;_ end of command
      (command "_arc" pt6    "_e"   pt7	   "_r"	  rd1	 "_arc"	pt2
	       "_e"   pt3    "_r"   rd1	   "_arc" pt5	 "_e"	pt4
	       "_r"   rd2
	      ) ;_  command
 ;_ end of command

    )			      ;    ug_sc

    (cond ((or (= glv1 "1") (= vsz1 "1")) (ug_gl_sz))
	  ((= sec1 "1") (ug_sc))
    ) ;_ end of cond

    (setvar "cmdecho" cmd)
    (setvar "blipmode" blpm)


    (while (setq label (entnext label))
      (setq sset (ssadd label sset))
    ) ;_ end of while

  ) ;_end of defun RIS_UGRP

  (defun edat ()
    (cond ((eq glv1 "1") (setq nmpr "A"))
	  ((eq vsz1 "1") (setq nmpr "C"))
	  ((eq sec1 "1") (setq nmpr "F"))
    ) ;_  cond
    (setq edat3 (strcat "E" nmpr pr_fl rr dlndt))
  ) ;_ end of defun

  (defun clip_bl ()
    (edat)
    (if	(eq (tblsearch "block" edat3) nil)
      (progn
	(ris_ugrp)
	(command "._block" edat3 cpt sset "")
	(setvar "aperture" apsz)
	(setvar "osmode" osmd)
	(setvar "clayer" clay)
	(command "._insert" edat3 pause 1 1 pause)
      ) ;_ end of progn
      (progn
	(setvar "clayer" clay)
	(command "._insert" edat3 pause 1 1 pause)
      ) ;_ end of progn
    ) ;_end of if
    (setvar "celtype" cltp)
    (setvar "cecolor" ccol)
  ) ;_ end of defun CLIP_BL

  (clip_bl)
  (prin1)

)			      ;    UG_RP
;|Visual LISP Format Options
(72 2 30 2 T " " 72 9 1 1 0 T T nil T)
;***     ! ***|;
